#include <iostream>

using namespace std;

typedef struct 
{
  char typ;
} bludiste;

bludiste blud[100] [100];
int velx, vely;

struct prochazim
{
  int pozice;
  int predchozi;
  char keys[4];
  int x, y;
  bool smim (int smerx, int smery)
  {
    if ((x + smerx < 0) || (x + smerx > velx)) return false;
    if ((y + smery < 0) || (y + smery > vely)) return false;
    char c = blud[x + smerx] [y + smery].typ;
    if (c == 'B' && !keys[0]) return false;
    if (c == 'Y' && !keys[1]) return false;
    if (c == 'R' && !keys[2]) return false;
    if (c == 'G' && !keys[3]) return false;
    if (blud[x + smerx] [y + smery].typ != '#') return true;  
    return false;
  }
};

prochazim pole [10001];

bool byljsem (int x, int y, const char * keys, int pozice)
{
  for (int i = 0; i < pozice; i++)
  {
    if (pole[i].x == x && pole[i].y == y && memcmp(pole[i].keys,keys,sizeof(char)*4)) return true;
  }
  return false;
}

bool vypln (int x, int y, char * keys, int &nakonec, int pos, int smerx, int smery)
{
  if (pole[pos].smim(smerx,smery) && !byljsem(x+smerx,y+smery, pole[pos].keys, pos))
  {
    pole[nakonec].x = x+smerx;
    pole[nakonec].y = y+smery;
    if (blud[x+smerx][y+smery].typ == 'X')
      return true;
    if (blud[x+smerx] [y+smery].typ == 'b')
    {
      pole[nakonec].keys[0] = 'b';
      blud [x+smerx] [y+smery].typ = '.';
    }
    if (blud[x+smerx] [y+smery].typ == 'y')
    {
      pole[nakonec].keys[1] = 'y';
      blud [x+smerx] [y+smery].typ = '.';
    }
    if (blud[x+smerx] [y+smery].typ == 'r')
    {
      pole[nakonec].keys[2] = 'r';
      blud [x+smerx] [y+smery].typ = '.';
    }
    if (blud[x+smerx] [y+smery].typ == 'g')
    {
      pole[nakonec].keys[3] = 'g';
      blud [x+smerx] [y+smery].typ = '.';
    }
    pole[nakonec].pozice = pos + 1;
    pole[nakonec].predchozi = pos;
    nakonec ++;
  }
  return false;
}

int main ()
{
  for (;;)
  {
    cin >> vely;
    cin.ignore(1);
    cin >> velx;
    cin.ignore(1);
    int stx, sty;
    if (!(velx + vely)) return 0;
    char c;
    bool mareseni = false;
    for (int i = 0; i < vely ; i++)
    {
      for (int j = 0; j < velx; j++)
      {
        cin.get (c);
        if (c == '*') 
        {
          stx = i;
          sty = j;
        }
        if (c == 'X')
        {
          mareseni = true;
        }
        blud[i] [j].typ = c;
      }
      cin.ignore(1);
    }
    //prochazeni
    if (!mareseni)
      cout << "zase kurva" << endl;
    bool konec = false;
    memset(pole,0,sizeof(prochazim)*10001);
    pole[0].pozice = 0;
    pole[0].predchozi = -1;
    pole[0].keys[0] = 0;
    pole[0].keys[1] = 0;
    pole[0].keys[2] = 0;
    pole[0].keys[3] = 0;
    pole[0].x = stx;
    pole[0].y = sty;
    int x, y;
    int pozice = 0;
    int konecpole = 1;
    while (!konec)
    {
      x = pole[pozice].x;
      y = pole[pozice].y;
      if (vypln(x,y,pole[pozice].keys,konecpole,pozice,0,1))
      {
        konec = true;
        continue;
      }
      if (vypln(x,y,pole[pozice].keys,konecpole,pozice,1,0))
      {
        konec = true;
        continue;
      }
      if (vypln(x,y,pole[pozice].keys,konecpole,pozice,-1,0))
      {
        konec = true;
        continue;
      }
      if (vypln(x,y,pole[pozice].keys,konecpole,pozice,0,-1))
      {
        konec = true;
        continue;
      }
      pozice ++;
      if (pozice > konecpole)
      {
        konec = true;
        mareseni = false;
      }
    }
    if (!mareseni)
      cout << "kurva" << endl;
  }
}
